'Demonstration of PCA9554 i2c Driver
'Copyright 2007 Raymond Allen
'WARNING: This code toggles all 8 pins LOW then HIGH.  Do not connect Vdd directly to a pin being driven LOW!

CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency

  PCA9554_Address = 32           'Change this if you don't have A0,A1,A2 all low on your 8574 chip (see datasheet)


OBJ  'Objects Section
    'Use the VGA (or TV) text driver to display status
    
  text : "vga_text"    'For NTSC TV Video: Comment out this line...
  'text : "tv_text"    'and un-comment this line  (need to change pin parameter for text.start(pin) command below too).

  expand1:  "PCA9554_i2cDriver"  'The object being demonstrated
  

PUB PCA9554_DEMO|data,bOk    'the first PUB routine is assumed the be the main one

  'Start up display and show some text
  
  text.start(16)    'Start the VGA/TV text driver (uses another cog)
                    'The parameter (16) is the base pin used by demo and proto boards for VGA output
                    'Change (16) to (12) when using "tv_text" driver with demo board as it uses pin#12 for video

  text.str(string("  ---- PCA9554 Demo ----"))  
  text.out(13)
  text.out(13)
  text.str(string("Toggling all PINS of PCA9554"))
  text.out(13) 
  text.str(string("at address 32 and "))
  text.out(13)
  text.str(string("reading while HIGH..."))  


  'Toggle all PCA9554 LOW then HIGH, each for 5 seconds
  'Also, take an input reading while all pins HIGH         (WARNING: You should, generally, only use as input with all pins HIGH !!!)
  
  repeat            'infinite loop
    'Output LOW
    bOk:=expand1.out(PCA9554_Address, 3, $00)  'configure all pins as ouputs  
    bOk:=expand1.out(PCA9554_Address, 1, $00)  'Set all pins low
    if (bOk)
       text.str(@StringLow)           'Ok message
    else
       text.str(@StringWriteError)    'Error message 
    waitcnt(cnt+CLKFREQ*5)  'wait 5 seconds
    
    'Output HIGH
    bOk:=expand1.out(PCA9554_Address, 1, 255)  'Set all pins HIGH
    if (bOk)  
      text.str(@StringHigh)           'OK message
    else
       text.str(@StringWriteError)    'Error message 
    waitcnt(cnt+CLKFREQ*1)  'wait 1 seconds
     
    'Input data
    bOk:=expand1.out(PCA9554_Address, 3, $FF)  'configure all pins as inputs
    bOk:=expand1.out(PCA9554_Address, 0, -1)  'command to input 
    data:=expand1.in(PCA9554_Address)   'get input data.  Note that P7 is MSBit and P0 is LSbit
    if (data=>0)
      text.str(@StringIn)
      repeat 8                  'show all 8 bits
        text.out("0"+(data&1))
        data->=1
    else
       text.str(@StringReadError)    'Error message        
    waitcnt(cnt+CLKFREQ*5)  'wait 4 seconds
    text.str(@StringEraser)  
    
    



DAT
StringWriteError byte $0A,2,$0B,7,"Write Error! ",0
StringLow  byte $0A,2,$0B,7,"All pins LOW ",0
StringHigh byte $0A,2,$0B,7,"All pins HIGH",0
StringIn byte $0A,1,$0B,9,"Input Data (P0..P7): ",0
StringEraser byte $0A,1,$0B,9,"                             ",0
StringReadError byte $0A,1,$0B,9,"Read Error!                  ",0


